Back to blog
Nov 19, 2024
3 min read

LeetCode 2461: Maximum Sum of Distinct Subarrays With Length K

Leetcode 2461: Maximum Sum of Distinct Subarrays With Length K solution in Python

Problem Description

LeetCode Problem 2461

You are given an integer array nums and an integer k. Find the maximum subarray sum of all the subarrays of nums that meet the following conditions:

  • The length of the subarray is k, and
  • All the elements of the subarray are distinct.

Return the maximum subarray sum of all the subarrays that meet the conditions. If no subarray meets the conditions, return 0.

A subarray is a contiguous non-empty sequence of elements within an array.

 

Example 1:

Input: nums = [1,5,4,2,9,9,9], k = 3
Output: 15
Explanation: The subarrays of nums with length 3 are:
- [1,5,4] which meets the requirements and has a sum of 10.
- [5,4,2] which meets the requirements and has a sum of 11.
- [4,2,9] which meets the requirements and has a sum of 15.
- [2,9,9] which does not meet the requirements because the element 9 is repeated.
- [9,9,9] which does not meet the requirements because the element 9 is repeated.
We return 15 because it is the maximum subarray sum of all the subarrays that meet the conditions

Example 2:

Input: nums = [4,4,4], k = 3
Output: 0
Explanation: The subarrays of nums with length 3 are:
- [4,4,4] which does not meet the requirements because the element 4 is repeated.
We return 0 because no subarrays meet the conditions.

 

Constraints:

  • 1 <= k <= nums.length <= 105
  • 1 <= nums[i] <= 105

Difficulty: Medium

Tags: array, hash table, sliding window

Rating: 98.13%

Solution Complexity

  • Time Complexity: O(?)
  • Space Complexity: O(?)

Could not extract solution code for analysis.

Solution

Here’s my Python solution to this problem:

class Solution:
    def maximumSubarraySum(self, nums: List[int], k: int) -> int:
        o = 0
        last_i = {}
        s = 0

        l = 0
        for r in range(0, len(nums)):
            s += nums[r]
            i = last_i.get(nums[r], -1)
            last_i[nums[r]] = r
            
            while l <= i or r-l+1 > k:
                s -= nums[l]
                l += 1

            if r - l + 1 == k:
                o = max(o, s)
        
        return o